// Copyright (c) 2016-2018 LG Electronics, Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// SPDX-License-Identifier: Apache-2.0

#ifndef _ERRORDB_H_
#define _ERRORDB_H_

#include <iostream>

using namespace std;

class ErrorDB {
public:
    static const int ERRORCODE_NOERROR;

    static const char *ERRORTEXT_UNKNOWN;
    static const int ERRORCODE_UNKNOWN;

    static const char *ERRORTEXT_INVALID_PARAMETER;
    static const int ERRORCODE_INVALID_PARAMETER;

    static const char *ERRORTEXT_INVALID_MAINDB;
    static const int ERRORCODE_INVALID_MAINDB;

    static const char *ERRORTEXT_JSON_PARSING;
    static const int ERRORCODE_JSON_PARSING;

    static const char *ERRORTEXT_RESPONSE;
    static const int ERRORCODE_RESPONSE;

    static const char *getErrorText(int errorCode);
    static const int getErrorCode(const char *errorText);

private:
    ErrorDB() {};
    virtual ~ErrorDB() {};
};

#endif /* _ERRORDB_H_ */
